# coding: utf-8

"""
    DLCM-Solution

    DLCM application wrapping all modules, All-In-One  # noqa: E501

    The version of the OpenAPI document: 2.1.1
    Contact: eresearch-opensource@unige.ch
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from dlcmapi_client.configuration import Configuration


class ArchiveRating(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'links': 'object',
        'archive_id': 'str',
        'creation': 'ChangeInfo',
        'grade': 'float',
        'last_update': 'ChangeInfo',
        'rating_type': 'ArchiveRatingRatingType',
        'res_id': 'str',
        'user': 'ArchiveRatingUser'
    }

    attribute_map = {
        'links': '_links',
        'archive_id': 'archiveId',
        'creation': 'creation',
        'grade': 'grade',
        'last_update': 'lastUpdate',
        'rating_type': 'ratingType',
        'res_id': 'resId',
        'user': 'user'
    }

    def __init__(self, links=None, archive_id=None, creation=None, grade=None, last_update=None, rating_type=None, res_id=None, user=None, local_vars_configuration=None):  # noqa: E501
        """ArchiveRating - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._links = None
        self._archive_id = None
        self._creation = None
        self._grade = None
        self._last_update = None
        self._rating_type = None
        self._res_id = None
        self._user = None
        self.discriminator = None

        if links is not None:
            self.links = links
        if archive_id is not None:
            self.archive_id = archive_id
        if creation is not None:
            self.creation = creation
        if grade is not None:
            self.grade = grade
        if last_update is not None:
            self.last_update = last_update
        if rating_type is not None:
            self.rating_type = rating_type
        if res_id is not None:
            self.res_id = res_id
        if user is not None:
            self.user = user

    @property
    def links(self):
        """Gets the links of this ArchiveRating.  # noqa: E501

        The _links_ list of the _archive-ratings_ resource  # noqa: E501

        :return: The links of this ArchiveRating.  # noqa: E501
        :rtype: object
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this ArchiveRating.

        The _links_ list of the _archive-ratings_ resource  # noqa: E501

        :param links: The links of this ArchiveRating.  # noqa: E501
        :type: object
        """

        self._links = links

    @property
    def archive_id(self):
        """Gets the archive_id of this ArchiveRating.  # noqa: E501

        The archive ID of the archive rating  # noqa: E501

        :return: The archive_id of this ArchiveRating.  # noqa: E501
        :rtype: str
        """
        return self._archive_id

    @archive_id.setter
    def archive_id(self, archive_id):
        """Sets the archive_id of this ArchiveRating.

        The archive ID of the archive rating  # noqa: E501

        :param archive_id: The archive_id of this ArchiveRating.  # noqa: E501
        :type: str
        """

        self._archive_id = archive_id

    @property
    def creation(self):
        """Gets the creation of this ArchiveRating.  # noqa: E501


        :return: The creation of this ArchiveRating.  # noqa: E501
        :rtype: ChangeInfo
        """
        return self._creation

    @creation.setter
    def creation(self, creation):
        """Sets the creation of this ArchiveRating.


        :param creation: The creation of this ArchiveRating.  # noqa: E501
        :type: ChangeInfo
        """

        self._creation = creation

    @property
    def grade(self):
        """Gets the grade of this ArchiveRating.  # noqa: E501

        The grade of the archive rating  # noqa: E501

        :return: The grade of this ArchiveRating.  # noqa: E501
        :rtype: float
        """
        return self._grade

    @grade.setter
    def grade(self, grade):
        """Sets the grade of this ArchiveRating.

        The grade of the archive rating  # noqa: E501

        :param grade: The grade of this ArchiveRating.  # noqa: E501
        :type: float
        """

        self._grade = grade

    @property
    def last_update(self):
        """Gets the last_update of this ArchiveRating.  # noqa: E501


        :return: The last_update of this ArchiveRating.  # noqa: E501
        :rtype: ChangeInfo
        """
        return self._last_update

    @last_update.setter
    def last_update(self, last_update):
        """Sets the last_update of this ArchiveRating.


        :param last_update: The last_update of this ArchiveRating.  # noqa: E501
        :type: ChangeInfo
        """

        self._last_update = last_update

    @property
    def rating_type(self):
        """Gets the rating_type of this ArchiveRating.  # noqa: E501


        :return: The rating_type of this ArchiveRating.  # noqa: E501
        :rtype: ArchiveRatingRatingType
        """
        return self._rating_type

    @rating_type.setter
    def rating_type(self, rating_type):
        """Sets the rating_type of this ArchiveRating.


        :param rating_type: The rating_type of this ArchiveRating.  # noqa: E501
        :type: ArchiveRatingRatingType
        """

        self._rating_type = rating_type

    @property
    def res_id(self):
        """Gets the res_id of this ArchiveRating.  # noqa: E501

        The _archive-ratings_ resource identifier [https://en.wikipedia.org/wiki/Universally_unique_identifier[UUID]]  # noqa: E501

        :return: The res_id of this ArchiveRating.  # noqa: E501
        :rtype: str
        """
        return self._res_id

    @res_id.setter
    def res_id(self, res_id):
        """Sets the res_id of this ArchiveRating.

        The _archive-ratings_ resource identifier [https://en.wikipedia.org/wiki/Universally_unique_identifier[UUID]]  # noqa: E501

        :param res_id: The res_id of this ArchiveRating.  # noqa: E501
        :type: str
        """

        self._res_id = res_id

    @property
    def user(self):
        """Gets the user of this ArchiveRating.  # noqa: E501


        :return: The user of this ArchiveRating.  # noqa: E501
        :rtype: ArchiveRatingUser
        """
        return self._user

    @user.setter
    def user(self, user):
        """Sets the user of this ArchiveRating.


        :param user: The user of this ArchiveRating.  # noqa: E501
        :type: ArchiveRatingUser
        """

        self._user = user

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ArchiveRating):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ArchiveRating):
            return True

        return self.to_dict() != other.to_dict()
